using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WebClient_UploadFile
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            buttonUpload.Enabled = false;
        }

        /// <summary>
        /// t@CI
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonFileSelect_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            textBoxFilePath.Text = openFileDialog1.FileName;
            buttonUpload.Enabled = true;
        }

        /// <summary>
        /// t@CAbv[h
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonUpload_Click(object sender, EventArgs e)
        {
            buttonUpload.Enabled = false;

            //Mt@C̃pX
            string filePath = textBoxFilePath.Text;
            string fileName = System.IO.Path.GetFileName(filePath);

            //MURL
            string url = "http://colinux/perl/070112_uploadFile/upload-simple.cgi";

            //R[h
            System.Text.Encoding enc = System.Text.Encoding.GetEncoding("utf-8");
            //؂蕶
            string boundary = System.Environment.TickCount.ToString();

            //WebRequest̍쐬
            System.Net.HttpWebRequest req = (System.Net.HttpWebRequest)
                System.Net.WebRequest.Create(url);
            //\bhPOSTw
            req.Method = "POST";
            //ContentTypeݒ
            req.ContentType = "multipart/form-data; boundary=" + boundary;

            //POSTMf[^쐬
            string postData = "";
            postData = "--" + boundary + "\r\n" +
                "Content-Disposition: form-data; name=\"comment\"\r\n\r\n" +
                "́AeXgłB\r\n" +
                "--" + boundary + "\r\n" +
                "Content-Disposition: form-data; name=\"upfile\"; filename=\"" +
                    fileName + "\"\r\n" +
                "Content-Type: application/octet-stream\r\n" +
                "Content-Transfer-Encoding: binary\r\n\r\n";
            //oCg^zɕϊ
            byte[] startData = enc.GetBytes(postData);
            postData = "\r\n--" + boundary + "\r\n";
            byte[] endData = enc.GetBytes(postData);

            //Mt@CJ
            System.IO.FileStream fs = new System.IO.FileStream(
                filePath, System.IO.FileMode.Open,
                System.IO.FileAccess.Read);

            //POSTMf[^̒w
            req.ContentLength = startData.Length + endData.Length + fs.Length;

            //f[^POSTM邽߂Stream擾
            System.IO.Stream reqStream = req.GetRequestStream();
            //Mf[^
            reqStream.Write(startData, 0, startData.Length);
            //t@C̓e𑗐M
            byte[] readData = new byte[0x1000];
            int readSize = 0;
            while (true)
            {
                readSize = fs.Read(readData, 0, readData.Length);
                if (readSize == 0)
                    break;
                reqStream.Write(readData, 0, readSize);
            }
            fs.Close();
            reqStream.Write(endData, 0, endData.Length);
            reqStream.Close();

            //T[o[̉M邽߂WebResponse擾
            System.Net.HttpWebResponse res =
                (System.Net.HttpWebResponse)req.GetResponse();
            //f[^M邽߂Stream擾
            System.IO.Stream resStream = res.GetResponseStream();
            //Mĕ\
            System.IO.StreamReader sr =
                new System.IO.StreamReader(resStream, enc);
            Console.WriteLine(sr.ReadToEnd());
            //
            sr.Close();


            buttonUpload.Enabled = true;

        }


    }
}